/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 6.1 of the 
*Andrew User Interface System and is 
*the property of IBM, Carnegie Mellon University, 
*and the other copyright holders.  The source 
*code of this version is for the sole use of 
*the individual named in ./config/allsys.h.  
*This source code is not to be redistributed.  
*Binary object code compiled or derived from 
*these sources is not to be distributed to non-
*members.  Members may have additional 
*distribution rights granted by prior written 
*permission of Carnegie Mellon University.
*
*IBM, CARNEGIE MELLON UNIVERSITY, 
*AND THE OTHER COPYRIGHT HOLDERS
* DISCLAIM ALL WARRANTIES WITH 
*REGARD TO THIS SOFTWARE, INCLUDING 
*ALL IMPLIED WARRANTIES OF MERCHANT-
*ABILITY AND FITNESS. IN 
*NO EVENT SHALL  IBM, CARNEGIE 
*MELLON UNIVERSITY, OR ANY OTHER 
*COPYRIGHT HOLDER BE LIABLE FOR 
*ANY SPECIAL, INDIRECT OR CONSE-
*QUENTIAL DAMAGES OR ANY DAMAGES 
*WHATSOEVER RESULTING FROM LOSS OF
*USE, DATA OR PROFITS, WHETHER IN AN
*ACTION OF CONTRACT, NEGLIGENCE OR
*OTHER TORTIOUS ACTION, ARISING OUT 
*OF OR IN CONNECTION WITH THE USE OR
*PERFORMANCE OF THIS SOFTWARE.
* $
*/


 


/* Generic application
 */

class application[app] {
    methods:
        ParseArgs(int argc,char **argv) returns boolean;
        ReadInitFile();
        Start() returns boolean;
        Run() returns int;
        Stop();
        Fork() returns boolean;
        PrintVersionNumber();
    macromethods:
        SetFork(do) (self->fork=(do))
        GetFork() (self->fork)

        SetName(str) (self->name=(str))
        GetName() (self->name)

        SetForceLoad(boolean f) ((self)->forceload=(f))
        GetForceLoad() ((self)->forceload)
        SetErrorProc(procedure p) ((self)->errorProc=(p))
        GetErrorProc() ((self)->errorProc)
        SetErrorRock(long r) ((self)->errorRock=(r))
        GetErrorRock() ((self)->errorRock)
        SetMajorVersion(long mv) ((self)->majorversion=(mv))
        GetMajorVersion() ((self)->majorversion)
        SetMinorVersion(long mv) ((self)->minorversion=(mv))
        GetMinorVersion() ((self)->minorversion)
        SetPrintVersionFlag(boolean TorF) ((self)->printversioninfo=(TorF))
	GetPrintVersionFlag() ((self)->printversioninfo)

	SetIconic(boolean val) ((self)->iconic=(val))
	GetIconic() ((self)->iconic)
      
    classprocedures:
        DeleteArgs(char **argv, int num);
        GetATKVersion() returns char *;
        InitializeObject(struct application *self) returns boolean;
        FinalizeObject(struct application *self);
    data:
        boolean fork;
        boolean forceload,readInitFile;
        char *profile; /* class to profile, "" for self, NULL for none */
        char *name;
        void (*errorProc)();
        pointer errorRock;
        char *fgcolor, *bgcolor;
        char *geometry;
        long majorversion, minorversion;
	boolean printversioninfo;
	boolean iconic;
};
