/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 6.1 of the 
*Andrew User Interface System and is 
*the property of IBM, Carnegie Mellon University, 
*and the other copyright holders.  The source 
*code of this version is for the sole use of 
*the individual named in ./config/allsys.h.  
*This source code is not to be redistributed.  
*Binary object code compiled or derived from 
*these sources is not to be distributed to non-
*members.  Members may have additional 
*distribution rights granted by prior written 
*permission of Carnegie Mellon University.
*
*IBM, CARNEGIE MELLON UNIVERSITY, 
*AND THE OTHER COPYRIGHT HOLDERS
* DISCLAIM ALL WARRANTIES WITH 
*REGARD TO THIS SOFTWARE, INCLUDING 
*ALL IMPLIED WARRANTIES OF MERCHANT-
*ABILITY AND FITNESS. IN 
*NO EVENT SHALL  IBM, CARNEGIE 
*MELLON UNIVERSITY, OR ANY OTHER 
*COPYRIGHT HOLDER BE LIABLE FOR 
*ANY SPECIAL, INDIRECT OR CONSE-
*QUENTIAL DAMAGES OR ANY DAMAGES 
*WHATSOEVER RESULTING FROM LOSS OF
*USE, DATA OR PROFITS, WHETHER IN AN
*ACTION OF CONTRACT, NEGLIGENCE OR
*OTHER TORTIOUS ACTION, ARISING OUT 
*OF OR IN CONNECTION WITH THE USE OR
*PERFORMANCE OF THIS SOFTWARE.
* $
*/


 


#include <atom.ih>

struct atoms 
{
    struct atom *atom;
    struct atoms *next;
};

class atomlist {
methods:
  Last() returns struct atom *;
    Memberp(struct atom *list) returns short;
  DropFirst();
    Prepend(struct atom *newitem);
    Append(struct atom *newitem);
    JoinToEnd(struct atomlist *otherlist);
    JoinToBeginning(struct atomlist *otherlist);
    Cut(struct atoms *mark);
macromethods:
    TraversalStart() (self->atoms)
    TraversalNext(struct atoms *loc) \
            ((loc) == NULL ? NULL : (loc)->next)
    TraversalAtom(struct atoms *loc) \
            ((loc) == NULL ? NULL : (loc)->atom)
    First() (self->atoms != NULL ? self->atoms->atom : NULL)
    Mark() (self->atoms)
classprocedures:
    InitializeObject(struct atomlist *self) returns boolean;
    FinalizeObject(struct atomlist *trashed);
    Copy(struct atomlist *oldlist) returns struct atomlist *;
    StringToAtomlist(char *string) returns struct atomlist *;
    /* (... assumes it can transiently smudge its input string) */
data:
    struct atoms *atoms;
};
