/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 6.1 of the 
*Andrew User Interface System and is 
*the property of IBM, Carnegie Mellon University, 
*and the other copyright holders.  The source 
*code of this version is for the sole use of 
*the individual named in ./config/allsys.h.  
*This source code is not to be redistributed.  
*Binary object code compiled or derived from 
*these sources is not to be distributed to non-
*members.  Members may have additional 
*distribution rights granted by prior written 
*permission of Carnegie Mellon University.
*
*IBM, CARNEGIE MELLON UNIVERSITY, 
*AND THE OTHER COPYRIGHT HOLDERS
* DISCLAIM ALL WARRANTIES WITH 
*REGARD TO THIS SOFTWARE, INCLUDING 
*ALL IMPLIED WARRANTIES OF MERCHANT-
*ABILITY AND FITNESS. IN 
*NO EVENT SHALL  IBM, CARNEGIE 
*MELLON UNIVERSITY, OR ANY OTHER 
*COPYRIGHT HOLDER BE LIABLE FOR 
*ANY SPECIAL, INDIRECT OR CONSE-
*QUENTIAL DAMAGES OR ANY DAMAGES 
*WHATSOEVER RESULTING FROM LOSS OF
*USE, DATA OR PROFITS, WHETHER IN AN
*ACTION OF CONTRACT, NEGLIGENCE OR
*OTHER TORTIOUS ACTION, ARISING OUT 
*OF OR IN CONNECTION WITH THE USE OR
*PERFORMANCE OF THIS SOFTWARE.
* $
*/



/*  compress.ch:  Compress code areas is source text views. */

class compress: text {

  classprocedures:
    InitializeObject(struct compress *self)returns boolean;
    FinalizeObject(struct compress *self);
    InitializeClass() returns boolean; 
    CurrentIndentation(struct text *txt,long pos) returns int;

  overrides:
    Read (FILE *file, long id) returns long;

  methods:
    GetStyle(struct text *txt);
    Compress(struct text *txt,long pos,long len);
    NextCompressLoc(struct text *txt,long startpos,int ind) returns long;
    Decompress(struct text *txt);
    IsHidden(struct text *txt,long pos) returns boolean;

  macromethods:
    GetLocatn() ((self)->locatn)
    SetLocatn(long newValue) ( ((self)->locatn) = (newValue) )
    GetCprsLength() ((self)->length)
    SetCprsLength(long newValue) ( ((self)->length) = (newValue) )
    GetLines() ((self)->lines)
    SetLines(long nlines) ( ((self)->lines) = (nlines) )
    GetParenttxt() ((self)->parenttext)

  data:
    struct mark *cpmark;
    long lines;
    struct text *parenttext;
    struct textview *parentview;
    struct envlist *envl;
    struct style *compressed_style;
};

