/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 6.1 of the 
*Andrew User Interface System and is 
*the property of IBM, Carnegie Mellon University, 
*and the other copyright holders.  The source 
*code of this version is for the sole use of 
*the individual named in ./config/allsys.h.  
*This source code is not to be redistributed.  
*Binary object code compiled or derived from 
*these sources is not to be distributed to non-
*members.  Members may have additional 
*distribution rights granted by prior written 
*permission of Carnegie Mellon University.
*
*IBM, CARNEGIE MELLON UNIVERSITY, 
*AND THE OTHER COPYRIGHT HOLDERS
* DISCLAIM ALL WARRANTIES WITH 
*REGARD TO THIS SOFTWARE, INCLUDING 
*ALL IMPLIED WARRANTIES OF MERCHANT-
*ABILITY AND FITNESS. IN 
*NO EVENT SHALL  IBM, CARNEGIE 
*MELLON UNIVERSITY, OR ANY OTHER 
*COPYRIGHT HOLDER BE LIABLE FOR 
*ANY SPECIAL, INDIRECT OR CONSE-
*QUENTIAL DAMAGES OR ANY DAMAGES 
*WHATSOEVER RESULTING FROM LOSS OF
*USE, DATA OR PROFITS, WHETHER IN AN
*ACTION OF CONTRACT, NEGLIGENCE OR
*OTHER TORTIOUS ACTION, ARISING OUT 
*OF OR IN CONNECTION WITH THE USE OR
*PERFORMANCE OF THIS SOFTWARE.
* $
*/



/* ctext.ch: Text subclass specialized for dealing with C code. */

/* kinds of styles that are used in hash table */
#define KEYWRD 1     /* keywords */

class ctext: srctext {

  overrides:
    Indentation(long pos) returns int;
    IsTokenChar(char ch) returns boolean;
    Quoted(long pos) returns boolean;
    RedoStyles();
    SetAttributes(struct attributes *atts);
    SetupStyles();

  methods:
    BackwardSkipDelimited(long pos,char begin,char end) returns long;
    BackwardSkipJunk(long pos) returns long;
    MaybeBackwardSkipCppLines(long pos) returns long;
    UnstyledCommentStart(long pos) returns long;

  classprocedures:
    InitializeClass() returns boolean;
    InitializeObject(struct ctext *self) returns boolean;
 
  macromethods:

  data:
    /* Variables used to control the indenting style. */
    int braceIndent, switchLabelUndent, switchLevelIndent;
};

