/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 6.1 of the 
*Andrew User Interface System and is 
*the property of IBM, Carnegie Mellon University, 
*and the other copyright holders.  The source 
*code of this version is for the sole use of 
*the individual named in ./config/allsys.h.  
*This source code is not to be redistributed.  
*Binary object code compiled or derived from 
*these sources is not to be distributed to non-
*members.  Members may have additional 
*distribution rights granted by prior written 
*permission of Carnegie Mellon University.
*
*IBM, CARNEGIE MELLON UNIVERSITY, 
*AND THE OTHER COPYRIGHT HOLDERS
* DISCLAIM ALL WARRANTIES WITH 
*REGARD TO THIS SOFTWARE, INCLUDING 
*ALL IMPLIED WARRANTIES OF MERCHANT-
*ABILITY AND FITNESS. IN 
*NO EVENT SHALL  IBM, CARNEGIE 
*MELLON UNIVERSITY, OR ANY OTHER 
*COPYRIGHT HOLDER BE LIABLE FOR 
*ANY SPECIAL, INDIRECT OR CONSE-
*QUENTIAL DAMAGES OR ANY DAMAGES 
*WHATSOEVER RESULTING FROM LOSS OF
*USE, DATA OR PROFITS, WHETHER IN AN
*ACTION OF CONTRACT, NEGLIGENCE OR
*OTHER TORTIOUS ACTION, ARISING OUT 
*OF OR IN CONNECTION WITH THE USE OR
*PERFORMANCE OF THIS SOFTWARE.
* $
*/


/*srctextv.ch: Text View subclass specialized for dealing with source code text views. */

class srctextview[srctextv]: textview[textv] {
 
  overrides:
    PostMenus(struct menulist *menulist);
    ReceiveInputFocus();
    SetDataObject(struct srctext *dataobj);

  methods:
    Compress();
    CompressAll();
    ConfirmReadOnly() returns boolean;
    DecompressAll(long dummy);
    DeleteMenuItem(char menuitem[]);
    EndComment(char key);
    FindSubFile(char *filename, char *bufname, char *procname, char *searchpath) returns boolean;
    ForceUpperOn();
    ForceUpperOff();
    GotoColumn(int rock);
    HandleNewlineAndRetrn(long key,boolean reindentThisLine,boolean preindentNewLine);
    InsertComment();
    InsertLineComment();
    MatchParens(char key);
    Paren(char key);
    PrependKeyState() returns struct keystate *;
    PutFileIntoNewWindow(char *bufname, char *proc, char *filename);
    RedoStyles();
    Reformat();
    Reindent();
    RenameIdent();
    SelfInsert(char key);
    SelfInsertReindent(char key);
    StartComment(char key);
    StartLineComment(char key);
    WaitCursorOn();
    WaitCursorOff();
    WhatColumn();

  classprocedures:
    InitializeClass() returns boolean;
    InitializeObject(struct srctextview *self) returns boolean;
    FinalizeObject(struct srctextview *self);
 
  macromethods:

  data:
    struct keystate *src_state;
    struct menulist *src_menus;    
};
